# MWSE Nedir?

MWSE yani Micro Web Socket Engine, kendisine bağlanan eşleri birbirlerini ile eşleştirerek, eşler arası veri tüneli oluşturur.

Bağlantı TCP tabanlı yüksek hızlı WebSocket protokolüne dayanır ve sunucunun cihazları sanallaştırması sayesinde diğer kişilerin IP adreslerini veya cihaz türü gibi bilgilere ihtiyaç duymadan çift taraflı iletişim kurmalarını sağlar.

![image](https://www.hitechmv.com/wp-content/uploads/2014/05/startopology.jpg)

# MWSE Versiyon Dağılımı
```
V1 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V2 ----------------------------------> Next version Planning
V2 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V3 ------------------------> Next version Planning
V1 ------------------------> Add Deprecation warnings & adding documentation
V3 Prealpha ---> Alpha ----> Beta --->  Stable ---> LTS Stable
V1 -----------------------------------------------> Unpublish Release
```
| Stage | Name | Job | 
|-|-|-|
| 1 | V1 | Prealpha |
| 2 | V1 | Alpha |
| 3 | V1 | Beta |
| 4 | V1 | Stable |
| 5 | V2 | Next version Planning |
| 6 | V1 | LTS Stable / Publish Release |
| 7 | V2 | Prealpha |
| 8 | V2 | Alpha |
| 9 | V2 | Beta |
| 10 | V3 | Next version Planning |
| 11 | V1 | Add Deprecation warnings & adding documentation |
| 12 | V2 | LTS Stable / Publish Release |
| 13 | V3 | Prealpha |
| 14 | V3 | Alpha |
| 15 | V3 | Beta |
| 16 | v2 | Add Deprecation warnings & adding documentation |
| 17 | V3 | Stable |
| 18 | V1 | Unpublish/Remove Release |
| 19 | V3 | LTS Stable / Publish Release |
| 20 | V3 | Finish Project |
---

# Versiyon 1.0

## Prealpha yayının bitişi

- [x] WebSocket bağlantısı ve başarılı client kurulumu
- [x] TLS yapılandırması ve wss yönlendirme
- [x] Client UUID Hashing ve socket havuzu
- [x] Tek kanaldan birden çok Request/Response mantığı
- [x] Promise uyumlu / Async sunucu yapısı

## Alpha yayının bitişi

- [x] Session ve kişiye özel oturum bilgisi tutma
- [x] <s>Kayıtlı kullanıcı oturum açma ve kayıt olma</s>
- [x] Kişiler arası haberleşme
- [x] Kişileri eşleştirme ve tünelleme (kişiler arası veri aktarımı)
- [x] Oda mantığı / Odaya açma / odaya katılma / şifreli oda / herkese açık oda
- [x] Oda bildirimleri / broadcasting / kullanıcı katılma ayrılma bildirimleri

## Beta yayınının bitişi

- [ ] Client taraflı typescript kütüphane yayını
    - [ ] Promise yapısı
    - [ ] ID bilgilendirme oryantasyonu
    - [ ] Oda listeleme / açma / kapatma / katılma / davet sistemi
    - [ ] Client el sıkışma / reddetme
    - [ ] Cliente mesaj gönderme alma
- [ ] Admin dashboard / veri aktarımı limiti

## Stabil yayının bitişi

- [ ] Herkese açık belgelendirme

## LTS Stabil Sürüm

- [ ] Yedekleme ve loglama

---

# Planlanan Versiyon 2.0

- İki veri gönderimi
- Kullanıcı girişi kaydı ve api servisleri
- WebRTC Streaming / P2P Mesajlaşma
- İki kanal WebSocket (Aktif aktarım / Pasif aktarım)
- WebRTC Streaming / Görüntü ve Ses akışı
- WebRTC Streaming / Dosya akışı