"use strict";

let http = require("http");
let express = require("express");
let compression = require("compression");
let server = http.createServer();
let app = express();
server.addListener("request", app);
app.use(compression({
    level: 9
}));
server.listen(7707,'0.0.0.0',() => {
    console.log("HTTP Service Running...");
});
exports.http = server;


let {resolve} = require("path");
app.get("/script",(request, response)=>{
    response.sendFile(resolve("./script/index.js"))
});
app.get("*",(request, response)=>{
    response.sendFile(resolve("./script/status.xml"))
});